﻿var ResponseData = null;
var ResponseDataItem = null;
var DataPoint = null;
var ScoData = null;

var ScoJSonConverter =
    {
        // Initializes temporary variables
        InitializeSJSONandSD: function () {
            ResponseData = null;

            ResponseDataItem =
            {
                ItemID: 0,
                ResponseData: [],
                RestoreState: ""			// this is from the content and is consumed by the content
            };

            DataPoint =
              {
                  // this is the basic response data.  The renderers are responsible for translating whatever the content gives into this format
                  PointID: 0,		            // from the item
                  RawScore: 0.0,		        // from the item
                  Weight: 0.0,		        // some items will know this others won’t, and the Driver will have to populate it from the Assessment.xml.  If the item doesn’t know it should be set to 1
                  SkillGroupID: 0,		    // currently this is a string, but Keith wants it to be an int,  I agree.
                  IsScored: false,	        // again, some items will know this and others won’t if not assume true
                  ResponseData: "",	        // from the item, we just store it and pass it up to Portal
                  LessonStatus: "",
                  StudentPreferenceText: ""
              };
            ScoData = new Array();
        },

        // Function to get values from old sco json format
        ExtractValue: function (data, name) {
            var item = angular.Array.filter(data, function (p) { return p.name === name; });
            if (1 <= item.length) {
                return (item[0].value);
            }
            else {
                return ("");
            }
        },

        // Driver state -> Content state. aka Content input object creation.
        ParseState: function (data) {
            if (data) {
                // If array exist
                var counter = 0;

                //First things first, add comments. Comments are Restore state.
                var comments = {};
                comments.name = "cmi.comments";
                //DnR used to save the restore state with all of it's extras. We don't do that anymore.
                //Just in case we need to render state that was saved in the old format (by default)
                var restoreState = data.RestoreState;
                if (data.correctRestoreState) {
                    //Content is expecting a stringified version of our restore state.
                    restoreState = JSON.stringify({ items: [{ AttrName: "lms_ans", Value: data.RestoreState }] });
                }
                comments.value = restoreState;
                comments.isDirty = false;
                ScoData.push(comments);

                // Get first raw score
                var coreRawScore = {};
                coreRawScore.name = "cmi.core.score.raw";
                coreRawScore.value = data.ResponseData[0].RawScore.toString();
                coreRawScore.isDirty = false;
                ScoData.push(coreRawScore);

                if (data.ResponseData.length > 1) {

                    while (counter < data.ResponseData.length) {

                        var interactionRawScore = {};
                        interactionRawScore.name = "cmi.interactions." + counter + ".objectives." + counter + ".score.raw";
                        interactionRawScore.value = data.ResponseData[counter].RawScore.toString();
                        interactionRawScore.isDirty = false;
                        ScoData.push(interactionRawScore);

                        var objectiveStatus = {};
                        objectiveStatus.name = "cmi.objectives." + counter + ".status";
                        objectiveStatus.value = data.ResponseData[counter].LessonStatus;
                        objectiveStatus.isDirty = false;
                        ScoData.push(objectiveStatus);
                        counter++;
                    }

                }
                else {
                    var coreLessonStatus = {};
                    coreLessonStatus.name = "cmi.core.lesson_status";
                    coreLessonStatus.value = data.ResponseData[0].LessonStatus;
                    coreLessonStatus.isDirty = false;
                    ScoData.push(coreLessonStatus);

                    var studentPreference = {};
                    studentPreference.name = "cmi.student_preference.text";
                    studentPreference.value = data.ResponseData[0].StudentPreferenceText;
                    studentPreference.isDirty = false;
                    ScoData.push(studentPreference);
                }
            }
            return (ScoData);
        },

        // Content state -> Driver state. aka Driver state creation
        ParseResponse: function (data) {
            if (data) {
                // Check if cmi.interactions.0.objectives.0.score.raw..... exists
                ResponseDataItem.ResponseData = new Array();
                ResponseData = ResponseDataItem;

                var cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions.0.objectives.0.score.raw"; });
                if (1 <= cmi.length) {
                    var counter = 0;
                    // get cmi.interactions.... raw score
                    // objectiveRawScore
                    cmi = null;
                    cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions." + counter + ".objectives." + counter + ".score.raw"; });
                    while (1 <= cmi.length) {
                        var objectiveRawScore = DataPoint;
                        objectiveRawScore.PointID = counter;
                        objectiveRawScore.RawScore = cmi[0].value * 1;
                        ResponseData.ResponseData.push(objectiveRawScore);
                        cmi = null;
                        cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions." + ++counter + ".objectives." + counter + ".score.raw"; });
                    }

                    counter = 0;
                    // get cmi.interactions.... response
                    cmi = null;
                    cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions." + counter + ".responses"; });
                    while (1 <= cmi.length) {
                        ResponseData.ResponseData[counter].ResponseData = this.ExtractValue(data, "cmi.interactions." + counter + ".responses");

                        cmi = null;
                        cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions." + ++counter + ".responses"; });
                    }

                    counter = 0;
                    // get cmi.objectives.n.status
                    ResponseData.ResponseData[counter].LessonStatus = this.ExtractValue(data, "cmi.core.lesson_status");
                    cmi = null;
                    cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.objectives." + counter + ".status"; });
                    while (1 <= cmi.length) {
                        ResponseData.ResponseData[counter].LessonStatus = this.ExtractValue(data, "cmi.objectives." + counter + ".status");

                        cmi = null;
                        cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.objectives." + ++counter + ".status"; });
                    }

                    counter = 0;
                    // get cmi.student_preference.text
                    cmi = null;
                    cmi = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.student_preference.text"; });
                    if (1 <= cmi.length) {
                        ResponseData.ResponseData[counter].StudentPreferenceText = this.ExtractValue(data, "cmi.student_preference.text");
                    }

                }
                else // Use cmi.core.score.raw
                {
                    var score = DataPoint;
                    var boolCorrect = false;

                    // *************************************
                    // Special case for Captivate Exam types
                    // *************************************
                    var lessonStatus = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.core.lesson_status"; });
                    var interactionResult = angular.Array.filter(data, function (p) { return p.name.substring(0) === "cmi.interactions.0.result"; });
                    if ((1 <= lessonStatus.length) && (1 <= interactionResult.length)) {
                        boolCorrect = ((this.ExtractValue(data, "cmi.core.lesson_status") === "passed") &&
                            (this.ExtractValue(data, "cmi.interactions.0.result") === "correct") &&
                            (this.ExtractValue(data, "cmi.core.score.raw") === "0"));
                    }
                    // This logic is used for CS5 Exam Simulations
                    if (!boolCorrect && lessonStatus.length >= 1) {
                        boolCorrect = ((this.ExtractValue(data, "cmi.core.lesson_status") === "passed") &&
                           (this.ExtractValue(data, "cmi.core.score.raw") === "0"));
                    }

                    // Set values
                    score.PointID = 0;
                    if (boolCorrect)
                        score.RawScore = 100;
                    else
                        score.RawScore = this.ExtractValue(data, "cmi.core.score.raw") * 1;

                    // Get lesson status
                    score.LessonStatus = this.ExtractValue(data, "cmi.core.lesson_status");

                    ResponseData.ResponseData.push(score);
                }
                ResponseData.correctRestoreState = true;
                var comments = this.ExtractValue(data, "cmi.comments");
                try {
                    ResponseData.RestoreState = JSON.parse(comments).items[0].Value;
                } catch (err) {
                    //If comments are null or empty .. it gives me problems if I check in an if-clause
                }
                return (ResponseData);
            }
            else {
                return {};
            }
        }
    };