﻿var secs = 0,
	totalItem = 0,
	timer;
var isTimerActive = false;
var isReviewing = false;
var examMode = "Default";
var okButton = {};
var navTypeComplex = "complex";
var isLastItemReached = false;
var isAutomated = false;

$("#timerExpiredBtn").click(function () {
	okEndExam();
});

$("#errorBtn").click(function () {
	okEndExam();
});

function okEndExam() {
	$.ajax({
		type: 'POST',
		url: '/End',
		data: { timeRemaining: secs },
		success: function () {
			window.location.href = "/Close";
		},
		error: errorEncountered
	});
};

$(function () {
	/*
	 * this swallows backspace keys on any non-input element.
	 * stops backspace -> back
	 */
	var rx = /INPUT|SELECT|TEXTAREA/i;

	$(document).bind("keydown keypress", function (e) {
		if (e.which == 8) { // 8 == backspace
			if (!rx.test(e.target.tagName) || e.target.disabled || e.target.readOnly) {
				e.preventDefault();
			}
		}
	});
});

$(document).ready(function () {
	$.ajax({
		type: 'GET',
		url: '/Home/LoadFirstItem',
		success: function (data) {
			isAutomated = data.IsAutomated;
			var isHammer = data.URI.match(/shell/i);
			if (!isHammer) {
				timerPaused++;
			}
			if (data.totalInvolvedSec >= data.TotalSeconds) {
				endExam();
			}
			
		},
		error: errorEncountered
	});

	
	/* Debug Region */

	$("#btnDebugTenSecondsLeft").click(function () {
		$('#divDebugModeContainer').hide();
		if (isTimerActive == true) {
			isTimerActive = false;
			pauseTimer();
		}
		startTimer(10);
	});

	$("#btnDebugTimeLeft").click(function () {
		$('#divDebugModeContainer').hide();
		if (isTimerActive == true) {
			isTimerActive = false;
			pauseTimer();
		}
		startTimer($("#txtTimeLeft").val() * 1 == 0 ? 60 : $("#txtTimeLeft").val() * 60);
	});

	$("#btnDebugReviewPage").click(function () {
		$('#divDebugModeContainer').hide();
		$('#btnMenu').click();
	});

	$("#btnGoto").click(function () {
		$('#divDebugModeContainer').hide();
		returnToQuestion($("#txtQuestion").val());
	});

	$("#btnDebugFocus").click(function () {
		$('#divDebugModeContainer').hide();
		setTimeout(setFocus, 100);
	});

	$('#btnGetResult').click(function () {
		var itemState = GetResult();
		$.ajax({
			type: 'POST',
			url: '/Home/GetResultForDebug',
			data: itemState,
			success: function (data) {
				$('#txtDebugStatus').val(data.Status);
				$('#txtDebugRawScore').val(data.Score);
				$('#txtDebugWeight').val(data.Weight);
				$('#txtDebugState').val(JSON.stringify(JSON.parse(data.State).RestoreState));
			},
			error: errorEncountered
		});
	});

	$('#btnItemComment')
		.click(function () {
			$('#itemComment_dialog').dialog('open');
		});

	$('#itemCommentCloseBtn')
		.click(function () {
			$('#itemComment_dialog').dialog('close');
			$.ajax({
				type: 'POST',
				url: '/Home/ItemComment',
				data: new {
					Comments: $('#itemCommentText'),
					Rating: $('#ratingScale').rating()
			.val()
				}
			});
		});

	$('#btnNext').click(function () {
		//**Not sure if this code is still functional (should not be possible to be true)
		if (isLastItemReached) {
			$('#btnMenu').click();
			return;
		}
		//**End uncertanty
		$('#btnNext').attr('disabled', 'disabled');
		$('#btnPrevious').attr('disabled', 'disabled');
		var itemState = GetResult();
		$.ajax({
			type: 'POST',
			url: '/Home/NextItem?timeRemaining=' + secs,
			data: itemState,
			success: function (data) {
				if (data.LastItemReached == true) {
					if (isAutomated || reviewDisabled) {
						okEndExam();
					} else {
						$('#btnMenu').click();
					}
				}
				else {
					isLastItemReached = data.IsLastItem;
					window.location.href = "/StartExam";
				}
				setFocus();
			},
			error: errorEncountered
		});
	});

	$('#btnPrevious').click(function () {
		$('#btnNext').attr('disabled', 'disabled');
		$('#btnPrevious').attr('disabled', 'disabled');
		var itemState = GetResult();
		$.ajax({
			type: 'POST',
			url: '/Home/PreviousItem?timeRemaining=' + secs,
			data: itemState,
			success: function (data) {
				isLastItemReached = data.IsLastItem;
				window.location.href = "/StartExam";
			},
			error: errorEncountered
		});
	});

	$('#btnDebugStateOverride').click(function () {
		//GetResult returns a string, but we only want to override one part of that string
		//so we are converting it to an object
		var itemState = JSON.parse(GetResult());
		//Pull the new state that we want to override. Parse it. Let it fail if it's invalid - Debug only tool
		var newState = JSON.parse($('#txtDebugState').val());
		itemState.RestoreState = newState;
		$.ajax({
			type: 'POST',
			url: '/Home/GetResultForDebug?timeRemaining=' + secs,
			data: JSON.stringify(itemState),
			success: function (data) {
				if (data.LastItemReached == true) {
					$('#btnMenu').click();
				}
				else {
					window.location.href = "/StartExam";
				}
				setFocus();
			},
			error: errorEncountered
		});
	})

	$('#chkMarkForReview').click(function () {
		var isChecked = $(this).is(':checked');
		$.ajax({
			type: 'POST',
			url: '/Home/MarkItemForReview?isCheck=' + isChecked,
			success: function () { },
			error: errorEncountered
		});
	});

	$('#itemComment_dialog').dialog({
		autoOpen: false,
		modal: true,
		dialogClass: "noclose"
	});

	$('#timerexpired_dialog').dialog({
		autoOpen: false,
		modal: true,
		dialogClass: "noclose"
	});

	$("#error_dialog").dialog({
		autoOpen: false,
		modal: true,
		dialogClass: "noclose"
	});

	// Review Page Dialog
	$('#review_dialog').dialog({
		autoOpen: false,
		resizable: false,
		draggable: false,
		width: 930,
		height: 660,
		position: 'top',
		dialogClass: "noclose reviewButton",
		buttons: [{
			id: "reviewButtonTemp",
			text: reviewExit,
			click: function () {
				$.ajax({
					type: 'POST',
					url: '/End?timeRemaining=' + secs,
					data: { timeRemaining: secs },
					success: function () {
						window.location.href = "/Close";
					},
					error: errorEncountered
				});
			}
		}]
	}
	);

	$("#reviewButtonTemp").prop('title', reviewExit);
	$("#reviewButtonTemp").prop('tabindex', "0");

	$('#btnMenu').click(function () {
		if (isTimerActive == true) {
			isTimerActive = false;
			pauseTimer();
		}

		$('#divDebugModeContainer').hide();
		var navType = '';
		var itemState = GetResult();
		$.ajax({
			type: 'POST',
			dataType: 'json',
			url: '/Home/LoadItems?timeRemaining=' + secs,
			data: itemState,
			success: function (data) {
			}
		});

		isReviewing = true;
		return false;
	});

	// Set Debug mode
	$.ajax({
		type: 'GET',
		url: '/Home/GetExamMode',
		success: function (data) {

			examMode = data.ExamMode;

			if (examMode == "Debug") {
				$("#btnMode").css("cursor", "pointer");
				$('#btnMode').click(function () {
					$('#divDebugModeContainer').slideToggle("slow");
				});
				$('#counter').click(function () {
					clearTimeout(timer);
				});
			} else {
				$('.question').hide();
			}
		},
		error: errorEncountered
	});



});

// After focus version 2.
function DoBlurV2(element) {
	if (highContrast) {
		$(element).removeClass("ui-priority-primary driverButtonFocus").addClass("buttonHighContrast");
	}
	else {
		$(element).removeClass().addClass("ui-button ui-priority-primary medium");
	}
}

function returnToQuestion(itemId) {
	isReviewing = false;
	LoadBlankPage();
	var questionURL = '/Home/ReturnToQuestion?itemId=' + itemId + '&timeRemaining=' + secs;
	$.ajax({
		type: 'POST',
		url: questionURL,
		data: { itemId: itemId, timeRemaining: secs },
		success: function (data) {
			window.location.href = "/StartExam";

			//LoadSCORenderer(data.URI, data.ItemState);
			//$('#divWhiteLabel').show();
			//$('#divNavigation').show();
			//$('#btnNext').hide();//.css('visibility', 'hidden');
			//$('#btnPrevious').hide();//.css('visibility', 'hidden');
			//$('#btnMenu').show()//.css('visibility', 'visible');
			//$('#chkMarkForReview').prop('checked', data.MarkForReview);
			//$('.question').html('Question: ' + data.URI);
			//$('#lblResult').html('Result:');
			//navigate(data.CurrentItemNo, data.PreviousNavigationAvailable, true, data.Count);
			//$('#review_dialog').dialog("close");
			//$('#btnNext').hide();//.css('visibility', 'hidden');
			//$('#btnMenu').show();//.css('visibility', 'visible');
			//$('#questionNumber').show();
			//setFocus();
		},
		complete: function () {
			$('#contentFrame').css('visibility', 'visible');
			//$('#contentFrame').css({ width:"100%",height:"95%" });
		},
		error: errorEncountered
	});
}

function endExam() {
	$('#contentFrame').css('visibility', 'hidden');
	$.ajax({
		type: 'POST',
		url: '/Home/EndExam?timeRemaining=' + secs,
		data: { timeRemaining: secs },
		success: function (data) {

			if (data.Success) {
				$('#timerexpired_dialog').dialog('open');
				$('#btnNext').attr('disabled', true);
				$('#btnMenu').attr('disabled', true);
				$('#btnPrevious').attr('disabled', true);
				$('#chkMarkForReview').attr('disabled', true);
			}
		},
		error: errorEncountered
	});
}

function errorEncountered() {
	$.ajax({
		type: 'POST',
		url: '/Home/ExamError',
		success: function (data) {

			if (data.Success) {

				$('#error_dialog').dialog('open');
			}
		}
	});
}

// Navigation
function navigate(currentItemNo, previousNavigationAvailable, fromMenu, countItems, pageType) {
	$('#itemNavigation').text(currentItemNo + ' / ' + totalItem);
	$('#itemNavigation').prop('title', currentItemNo + ' / ' + totalItem); // Accessibility tooltip.
	$('#itemNavigation').prop('aria-label', currentItemNo + ' / ' + totalItem); // Accessibility Navigator on focus. not sure this is working now...

	if (fromMenu) {
		$('#btnNext').hide();
		$('#btnPrevious').hide();//.css('visibility', 'hidden');
		$('#btnMenu').show();//.css('visibility', 'visible');
		return;
	}

	if (previousNavigationAvailable == true && currentItemNo > 1) {
		$('#btnPrevious').show();
	} else {
		$('#btnPrevious').hide();
	}
	$('#btnMenu').hide();
	$('#btnNext').show();//.css('visibility', 'visible');
}

// Timer Related Functions //
function checkPauseTimer() {
	if (isTimerActive == true && isReviewing == false) {
		isTimerActive = false;
		pauseTimer();
	}
}

function checkUnpauseTimer() {
	$('#btnNext').removeAttr('disabled');
	$('#btnPrevious').removeAttr('disabled');
	$('#btnMenu').removeAttr('disabled');

	if (isTimerActive == false) {
		isTimerActive = true;
		startTimer(secs);
	}
	setFocus();
}


function PauseTimer() {
	checkPauseTimer();
	$.ajax({
		type: 'GET',
		url: '/TimerStoped',
		success: function (data) {
		}
	});
	timerPaused++;
}
//Count the number of times that the pause timer function has been called by content or the LMS API
//.. Automation will use this because hammer calls Pause and unPause once before content has loaded and once after - We care about the after
var timerPaused = 0;

function UnPauseTimer() {
	checkUnpauseTimer();
	$.ajax({
		type: 'GET',
		url: '/TimerStarted',
		success: function (data) {
		}
	});
	setFocus();
	//If running automation, simulate clicking the next button after content has loaded.
	if (isAutomated && timerPaused > 1) {
		//Flash Items aren't always completely loaded when they call UnPause
		setTimeout(clickNext, 250);
	}
}

function clickNext() {
	$('#btnNext').click();
}

function pauseTimer() {
	if (typeof timer != "undefined") {
		clearTimeout(timer);
	}
}

function startTimer(endTime) {
	if (endTime >= 0) {
		secs = endTime;
		var time = secondsToTime(secs);
		$('#counter').text(time);
		timer = setTimeout(function () { startTimer(secs - 1); }, 1000);
	}
}

function secondsToTime(secs) {
	if (secs > 0) {
		var hours = Math.floor(secs / (60 * 60));

		var divisorForMinutes = secs % (60 * 60);
		var minutes = Math.floor(divisorForMinutes / 60);

		var divisorForSeconds = divisorForMinutes % 60;
		var seconds = Math.ceil(divisorForSeconds);

		return pad(hours, 2) + ':' + pad(minutes, 2) + ':' + pad(seconds, 2);
	}
	else if (secs == 0) {
		endExam();
	}
	return '00:00:00';
}

function pad(number, length) {
	var str = '' + number;
	while (str.length < length) { str = '0' + str; }
	return str;
}
